# com.sap.apimgmt.sdk

## In case if you want to customize or enhance the generated project, import the project to an IDE of your choice and then follow the instructions given below to build, deploy and consume the library. 

Algorand Mainnet
- API version: 1.0
  - Build date: 2021-03-17T18:32:03.829Z

<p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, execute the following command::

```shell
mvn clean install
```

To deploy the API client library to a remote Maven repository, configure the settings of the repository and execute the following command:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add the following following dependency to your project's POM:

```xml
<dependency>
  <groupId>com.sap.apimgmt</groupId>
  <artifactId>com.sap.apimgmt.sdk</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add the following dependency to your project's build file:

```groovy
compile "com.sap.apimgmt:com.sap.apimgmt.sdk:1.0.0"
```

### Others

Generate the JAR by executing the following command:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/com.sap.apimgmt.sdk-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instructions given above and execute the following sample Java code to consume an API:

```java

import com.sap.apimgmt.sdk.client.*;
import com.sap.apimgmt.sdk.client.auth.*;
import com.sap.apimgmt.sdk.algorand_mainnet.model.*;
import com.sap.apimgmt.sdk.algorand_mainnet.api.AccountApi;

import java.io.File;
import java.util.*;

public class AccountApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();
        //Currently Base Path points to sandbox system, change it to call your API Endpoint
		defaultClient.setBasePath("https://acdevapi1.prod.apimanagement.us10.hana.ondemand.com:443/sapalgo/mainnet/");
		//You can obtain your API key on the Settings page of SAP API Business Hub. In the Settings page, choose the Show API Key toggle button to display and copy your API key. You have to be logged in to view your API Key.
		defaultClient.addDefaultHeader("APIKey","<YOUR APIBHUB SANDBOX APIKEY>"); 	
        */
        //Change Base Path, uncomment below code and configure API Key Authorization to call your API Endpoint: apikeyAuth
        /*ApiKeyAuth apikeyAuth = (ApiKeyAuth) defaultClient.getAuthentication("apikeyAuth");
        apikeyAuth.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //apikeyAuth.setApiKeyPrefix("Token");*/

        AccountApi apiInstance = new AccountApi();
        Object apIKey = null; // Object | API Key
        String address = "address_example"; // String | An account public key
        try {
            Account result = apiInstance.accountInformation(apIKey, address);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AccountApi#accountInformation");
            e.printStackTrace();
        }
    }
}

```

## Documentation for Models

 - [Account](docs/Account.md)
 - [AccountParticipation](docs/AccountParticipation.md)
 - [AccountStateDelta](docs/AccountStateDelta.md)
 - [Application](docs/Application.md)
 - [ApplicationLocalState](docs/ApplicationLocalState.md)
 - [ApplicationParams](docs/ApplicationParams.md)
 - [ApplicationStateSchema](docs/ApplicationStateSchema.md)
 - [Asset](docs/Asset.md)
 - [AssetHolding](docs/AssetHolding.md)
 - [AssetParams](docs/AssetParams.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [EvalDelta](docs/EvalDelta.md)
 - [EvalDeltaKeyValue](docs/EvalDeltaKeyValue.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [StateDelta](docs/StateDelta.md)
 - [TealKeyValue](docs/TealKeyValue.md)
 - [TealKeyValueStore](docs/TealKeyValueStore.md)
 - [TealValue](docs/TealValue.md)
 - [Version](docs/Version.md)
 - [VersionBuild](docs/VersionBuild.md)


## Documentation for Authorization

### apikeyAuth


- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues. 