/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.api;

import com.sap.apimgmt.sdk.client.ApiCallback;
import com.sap.apimgmt.sdk.client.ApiClient;
import com.sap.apimgmt.sdk.client.ApiException;
import com.sap.apimgmt.sdk.client.ApiResponse;
import com.sap.apimgmt.sdk.client.Configuration;
import com.sap.apimgmt.sdk.client.Pair;
import com.sap.apimgmt.sdk.client.ProgressRequestBody;
import com.sap.apimgmt.sdk.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.sap.apimgmt.sdk.algorand_mainnet.model.ErrorResponse;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse2001;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse2003;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BlockApi {
    private ApiClient apiClient;

    public BlockApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BlockApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getBlock
     * @param apIKey API Key (required)
     * @param round The round from which to fetch block information. (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getBlockCall(Object apIKey, Integer round, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/blocks/{round}"
            .replaceAll("\\{" + "round" + "\\}", apiClient.escapeString(round.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (format != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("format", format));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/msgpack"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getBlockValidateBeforeCall(Object apIKey, Integer round, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling getBlock(Async)");
        }
        
        // verify the required parameter 'round' is set
        if (round == null) {
            throw new ApiException("Missing the required parameter 'round' when calling getBlock(Async)");
        }
        

        com.squareup.okhttp.Call call = getBlockCall(apIKey, round, format, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get the block for the given round.
     * &lt;p&gt;Returns block information for the selected round.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param round The round from which to fetch block information. (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return InlineResponse2001
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse2001 getBlock(Object apIKey, Integer round, String format) throws ApiException {
        ApiResponse<InlineResponse2001> resp = getBlockWithHttpInfo(apIKey, round, format);
        return resp.getData();
    }

    /**
     * Get the block for the given round.
     * &lt;p&gt;Returns block information for the selected round.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param round The round from which to fetch block information. (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return ApiResponse&lt;InlineResponse2001&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse2001> getBlockWithHttpInfo(Object apIKey, Integer round, String format) throws ApiException {
        com.squareup.okhttp.Call call = getBlockValidateBeforeCall(apIKey, round, format, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse2001>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the block for the given round. (asynchronously)
     * &lt;p&gt;Returns block information for the selected round.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param round The round from which to fetch block information. (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getBlockAsync(Object apIKey, Integer round, String format, final ApiCallback<InlineResponse2001> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getBlockValidateBeforeCall(apIKey, round, format, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse2001>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for waitForBlock
     * @param apIKey API Key (required)
     * @param round The round to wait until returning status (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call waitForBlockCall(Object apIKey, Integer round, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/status/wait-for-block-after/{round}"
            .replaceAll("\\{" + "round" + "\\}", apiClient.escapeString(round.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call waitForBlockValidateBeforeCall(Object apIKey, Integer round, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling waitForBlock(Async)");
        }
        
        // verify the required parameter 'round' is set
        if (round == null) {
            throw new ApiException("Missing the required parameter 'round' when calling waitForBlock(Async)");
        }
        

        com.squareup.okhttp.Call call = waitForBlockCall(apIKey, round, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Gets the node status after waiting for the given round.
     * Waits for a block to appear after round {round} and returns the node&#39;s status at the time.
     * @param apIKey API Key (required)
     * @param round The round to wait until returning status (required)
     * @return InlineResponse2003
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse2003 waitForBlock(Object apIKey, Integer round) throws ApiException {
        ApiResponse<InlineResponse2003> resp = waitForBlockWithHttpInfo(apIKey, round);
        return resp.getData();
    }

    /**
     * Gets the node status after waiting for the given round.
     * Waits for a block to appear after round {round} and returns the node&#39;s status at the time.
     * @param apIKey API Key (required)
     * @param round The round to wait until returning status (required)
     * @return ApiResponse&lt;InlineResponse2003&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse2003> waitForBlockWithHttpInfo(Object apIKey, Integer round) throws ApiException {
        com.squareup.okhttp.Call call = waitForBlockValidateBeforeCall(apIKey, round, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse2003>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Gets the node status after waiting for the given round. (asynchronously)
     * Waits for a block to appear after round {round} and returns the node&#39;s status at the time.
     * @param apIKey API Key (required)
     * @param round The round to wait until returning status (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call waitForBlockAsync(Object apIKey, Integer round, final ApiCallback<InlineResponse2003> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = waitForBlockValidateBeforeCall(apIKey, round, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse2003>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
