/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.api;

import com.sap.apimgmt.sdk.client.ApiCallback;
import com.sap.apimgmt.sdk.client.ApiClient;
import com.sap.apimgmt.sdk.client.ApiException;
import com.sap.apimgmt.sdk.client.ApiResponse;
import com.sap.apimgmt.sdk.client.Configuration;
import com.sap.apimgmt.sdk.client.Pair;
import com.sap.apimgmt.sdk.client.ProgressRequestBody;
import com.sap.apimgmt.sdk.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.sap.apimgmt.sdk.algorand_mainnet.model.ErrorResponse;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse200;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse2004;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse2005;
import com.sap.apimgmt.sdk.algorand_mainnet.model.InlineResponse2006;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TransactionApi {
    private ApiClient apiClient;

    public TransactionApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TransactionApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getPendingTransactions
     * @param apIKey API Key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getPendingTransactionsCall(Object apIKey, Integer max, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/transactions/pending";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (max != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("max", max));
        if (format != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("format", format));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/msgpack"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getPendingTransactionsValidateBeforeCall(Object apIKey, Integer max, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling getPendingTransactions(Async)");
        }
        

        com.squareup.okhttp.Call call = getPendingTransactionsCall(apIKey, max, format, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool.
     * Get the list of pending transactions, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return InlineResponse200
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse200 getPendingTransactions(Object apIKey, Integer max, String format) throws ApiException {
        ApiResponse<InlineResponse200> resp = getPendingTransactionsWithHttpInfo(apIKey, max, format);
        return resp.getData();
    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool.
     * Get the list of pending transactions, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return ApiResponse&lt;InlineResponse200&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse200> getPendingTransactionsWithHttpInfo(Object apIKey, Integer max, String format) throws ApiException {
        com.squareup.okhttp.Call call = getPendingTransactionsValidateBeforeCall(apIKey, max, format, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse200>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool. (asynchronously)
     * Get the list of pending transactions, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPendingTransactionsAsync(Object apIKey, Integer max, String format, final ApiCallback<InlineResponse200> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPendingTransactionsValidateBeforeCall(apIKey, max, format, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse200>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getPendingTransactionsByAddress
     * @param apIKey API Key (required)
     * @param address An account public key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getPendingTransactionsByAddressCall(Object apIKey, String address, Integer max, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/accounts/{address}/transactions/pending"
            .replaceAll("\\{" + "address" + "\\}", apiClient.escapeString(address.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (max != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("max", max));
        if (format != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("format", format));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/msgpack"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getPendingTransactionsByAddressValidateBeforeCall(Object apIKey, String address, Integer max, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling getPendingTransactionsByAddress(Async)");
        }
        
        // verify the required parameter 'address' is set
        if (address == null) {
            throw new ApiException("Missing the required parameter 'address' when calling getPendingTransactionsByAddress(Async)");
        }
        

        com.squareup.okhttp.Call call = getPendingTransactionsByAddressCall(apIKey, address, max, format, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool by address.
     * Get the list of pending transactions by address, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param address An account public key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return InlineResponse200
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse200 getPendingTransactionsByAddress(Object apIKey, String address, Integer max, String format) throws ApiException {
        ApiResponse<InlineResponse200> resp = getPendingTransactionsByAddressWithHttpInfo(apIKey, address, max, format);
        return resp.getData();
    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool by address.
     * Get the list of pending transactions by address, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param address An account public key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return ApiResponse&lt;InlineResponse200&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse200> getPendingTransactionsByAddressWithHttpInfo(Object apIKey, String address, Integer max, String format) throws ApiException {
        com.squareup.okhttp.Call call = getPendingTransactionsByAddressValidateBeforeCall(apIKey, address, max, format, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse200>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a list of unconfirmed transactions currently in the transaction pool by address. (asynchronously)
     * Get the list of pending transactions by address, sorted by priority, in decreasing order, truncated at the end at MAX. If MAX &#x3D; 0, returns all pending transactions.
     * @param apIKey API Key (required)
     * @param address An account public key (required)
     * @param max Truncated number of transactions to display. If max&#x3D;0, returns all pending txns. (optional)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPendingTransactionsByAddressAsync(Object apIKey, String address, Integer max, String format, final ApiCallback<InlineResponse200> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPendingTransactionsByAddressValidateBeforeCall(apIKey, address, max, format, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse200>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for pendingTransactionInformation
     * @param apIKey API Key (required)
     * @param txid A transaction id (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call pendingTransactionInformationCall(Object apIKey, String txid, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/transactions/pending/{txid}"
            .replaceAll("\\{" + "txid" + "\\}", apiClient.escapeString(txid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (format != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("format", format));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call pendingTransactionInformationValidateBeforeCall(Object apIKey, String txid, String format, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling pendingTransactionInformation(Async)");
        }
        
        // verify the required parameter 'txid' is set
        if (txid == null) {
            throw new ApiException("Missing the required parameter 'txid' when calling pendingTransactionInformation(Async)");
        }
        

        com.squareup.okhttp.Call call = pendingTransactionInformationCall(apIKey, txid, format, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a specific pending transaction.
     * Given a transaction id of a recently submitted transaction, it returns information about it. There are several cases when this might succeed: - transaction committed (committed round &amp;gt; 0) - transaction still in the pool (committed round &#x3D; 0, pool error &#x3D; \&quot;\&quot;) - transaction removed from pool due to error (committed round &#x3D; 0, pool error !&#x3D; \&quot;\&quot;) Or the transaction may have happened sufficiently long ago that the node no longer remembers it, and this will return an error.
     * @param apIKey API Key (required)
     * @param txid A transaction id (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return InlineResponse2006
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse2006 pendingTransactionInformation(Object apIKey, String txid, String format) throws ApiException {
        ApiResponse<InlineResponse2006> resp = pendingTransactionInformationWithHttpInfo(apIKey, txid, format);
        return resp.getData();
    }

    /**
     * Get a specific pending transaction.
     * Given a transaction id of a recently submitted transaction, it returns information about it. There are several cases when this might succeed: - transaction committed (committed round &amp;gt; 0) - transaction still in the pool (committed round &#x3D; 0, pool error &#x3D; \&quot;\&quot;) - transaction removed from pool due to error (committed round &#x3D; 0, pool error !&#x3D; \&quot;\&quot;) Or the transaction may have happened sufficiently long ago that the node no longer remembers it, and this will return an error.
     * @param apIKey API Key (required)
     * @param txid A transaction id (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @return ApiResponse&lt;InlineResponse2006&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse2006> pendingTransactionInformationWithHttpInfo(Object apIKey, String txid, String format) throws ApiException {
        com.squareup.okhttp.Call call = pendingTransactionInformationValidateBeforeCall(apIKey, txid, format, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse2006>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a specific pending transaction. (asynchronously)
     * Given a transaction id of a recently submitted transaction, it returns information about it. There are several cases when this might succeed: - transaction committed (committed round &amp;gt; 0) - transaction still in the pool (committed round &#x3D; 0, pool error &#x3D; \&quot;\&quot;) - transaction removed from pool due to error (committed round &#x3D; 0, pool error !&#x3D; \&quot;\&quot;) Or the transaction may have happened sufficiently long ago that the node no longer remembers it, and this will return an error.
     * @param apIKey API Key (required)
     * @param txid A transaction id (required)
     * @param format Configures whether the response object is JSON or MessagePack encoded. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call pendingTransactionInformationAsync(Object apIKey, String txid, String format, final ApiCallback<InlineResponse2006> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = pendingTransactionInformationValidateBeforeCall(apIKey, txid, format, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse2006>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for rawTransaction
     * @param apIKey API Key (required)
     * @param rawtxn The byte encoded signed transaction to broadcast to network (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call rawTransactionCall(Object apIKey, byte[] rawtxn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = rawtxn;

        // create path and map variables
        String localVarPath = "/v2/transactions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-binary"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call rawTransactionValidateBeforeCall(Object apIKey, byte[] rawtxn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling rawTransaction(Async)");
        }
        
        // verify the required parameter 'rawtxn' is set
        if (rawtxn == null) {
            throw new ApiException("Missing the required parameter 'rawtxn' when calling rawTransaction(Async)");
        }
        

        com.squareup.okhttp.Call call = rawTransactionCall(apIKey, rawtxn, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Broadcasts a raw transaction to the network.
     * &lt;p&gt;Our SAP Integration API is based on the Algod API. The Algod API can be used for querying information from the blockchain, getting information about blocks and transactions, and sending transactions via the SAP Cloud Platform or S/4 HANA Systems. The KMD API, by contrast, is used for wallet management, key management, and signing transactions with private keys. Due to the privacy of such information, in case you would like to use the Key Management Demon API please contact us at&amp;nbsp;&lt;a href&#x3D;\&quot;mailto:solutions@alphacons.gr\&quot; rel&#x3D;\&quot;nofollow\&quot;&gt;solutions@alphacons.gr&lt;/a&gt;.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param rawtxn The byte encoded signed transaction to broadcast to network (required)
     * @return InlineResponse2004
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse2004 rawTransaction(Object apIKey, byte[] rawtxn) throws ApiException {
        ApiResponse<InlineResponse2004> resp = rawTransactionWithHttpInfo(apIKey, rawtxn);
        return resp.getData();
    }

    /**
     * Broadcasts a raw transaction to the network.
     * &lt;p&gt;Our SAP Integration API is based on the Algod API. The Algod API can be used for querying information from the blockchain, getting information about blocks and transactions, and sending transactions via the SAP Cloud Platform or S/4 HANA Systems. The KMD API, by contrast, is used for wallet management, key management, and signing transactions with private keys. Due to the privacy of such information, in case you would like to use the Key Management Demon API please contact us at&amp;nbsp;&lt;a href&#x3D;\&quot;mailto:solutions@alphacons.gr\&quot; rel&#x3D;\&quot;nofollow\&quot;&gt;solutions@alphacons.gr&lt;/a&gt;.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param rawtxn The byte encoded signed transaction to broadcast to network (required)
     * @return ApiResponse&lt;InlineResponse2004&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse2004> rawTransactionWithHttpInfo(Object apIKey, byte[] rawtxn) throws ApiException {
        com.squareup.okhttp.Call call = rawTransactionValidateBeforeCall(apIKey, rawtxn, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse2004>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Broadcasts a raw transaction to the network. (asynchronously)
     * &lt;p&gt;Our SAP Integration API is based on the Algod API. The Algod API can be used for querying information from the blockchain, getting information about blocks and transactions, and sending transactions via the SAP Cloud Platform or S/4 HANA Systems. The KMD API, by contrast, is used for wallet management, key management, and signing transactions with private keys. Due to the privacy of such information, in case you would like to use the Key Management Demon API please contact us at&amp;nbsp;&lt;a href&#x3D;\&quot;mailto:solutions@alphacons.gr\&quot; rel&#x3D;\&quot;nofollow\&quot;&gt;solutions@alphacons.gr&lt;/a&gt;.&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param rawtxn The byte encoded signed transaction to broadcast to network (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call rawTransactionAsync(Object apIKey, byte[] rawtxn, final ApiCallback<InlineResponse2004> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = rawTransactionValidateBeforeCall(apIKey, rawtxn, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse2004>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for transactionParams
     * @param apIKey API Key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call transactionParamsCall(Object apIKey, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/transactions/params";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (apIKey != null)
        localVarHeaderParams.put("APIKey", apiClient.parameterToString(apIKey));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apikeyAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call transactionParamsValidateBeforeCall(Object apIKey, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'apIKey' is set
        if (apIKey == null) {
            throw new ApiException("Missing the required parameter 'apIKey' when calling transactionParams(Async)");
        }
        

        com.squareup.okhttp.Call call = transactionParamsCall(apIKey, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get parameters for constructing a new transaction
     * &lt;p&gt;Get all the required parameters for constructing a new transaction and posting it to the blockchain&lt;/p&gt;
     * @param apIKey API Key (required)
     * @return InlineResponse2005
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public InlineResponse2005 transactionParams(Object apIKey) throws ApiException {
        ApiResponse<InlineResponse2005> resp = transactionParamsWithHttpInfo(apIKey);
        return resp.getData();
    }

    /**
     * Get parameters for constructing a new transaction
     * &lt;p&gt;Get all the required parameters for constructing a new transaction and posting it to the blockchain&lt;/p&gt;
     * @param apIKey API Key (required)
     * @return ApiResponse&lt;InlineResponse2005&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<InlineResponse2005> transactionParamsWithHttpInfo(Object apIKey) throws ApiException {
        com.squareup.okhttp.Call call = transactionParamsValidateBeforeCall(apIKey, null, null);
        Type localVarReturnType = new TypeToken<InlineResponse2005>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get parameters for constructing a new transaction (asynchronously)
     * &lt;p&gt;Get all the required parameters for constructing a new transaction and posting it to the blockchain&lt;/p&gt;
     * @param apIKey API Key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call transactionParamsAsync(Object apIKey, final ApiCallback<InlineResponse2005> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = transactionParamsValidateBeforeCall(apIKey, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<InlineResponse2005>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
