/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.sap.apimgmt.sdk.algorand_mainnet.model.AccountParticipation;
import com.sap.apimgmt.sdk.algorand_mainnet.model.Application;
import com.sap.apimgmt.sdk.algorand_mainnet.model.ApplicationLocalState;
import com.sap.apimgmt.sdk.algorand_mainnet.model.ApplicationStateSchema;
import com.sap.apimgmt.sdk.algorand_mainnet.model.Asset;
import com.sap.apimgmt.sdk.algorand_mainnet.model.AssetHolding;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Account information at a given round. Definition: data/basics/userBalance.go : AccountData
 */
@ApiModel(description = "Account information at a given round. Definition: data/basics/userBalance.go : AccountData")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class Account {
  @SerializedName("address")
  private String address = null;

  @SerializedName("amount")
  private Integer amount = null;

  @SerializedName("amount-without-pending-rewards")
  private Integer amountWithoutPendingRewards = null;

  @SerializedName("apps-local-state")
  private List<ApplicationLocalState> appsLocalState = null;

  @SerializedName("apps-total-schema")
  private ApplicationStateSchema appsTotalSchema = null;

  @SerializedName("assets")
  private List<AssetHolding> assets = null;

  @SerializedName("created-apps")
  private List<Application> createdApps = null;

  @SerializedName("created-assets")
  private List<Asset> createdAssets = null;

  @SerializedName("participation")
  private AccountParticipation participation = null;

  @SerializedName("pending-rewards")
  private Integer pendingRewards = null;

  @SerializedName("reward-base")
  private Integer rewardBase = null;

  @SerializedName("rewards")
  private Integer rewards = null;

  @SerializedName("round")
  private Integer round = null;

  @SerializedName("status")
  private String status = null;

  /**
   * Indicates what type of signature is used by this account, must be one of: * sig * msig * lsig
   */
  @JsonAdapter(SigTypeEnum.Adapter.class)
  public enum SigTypeEnum {
    SIG("sig"),
    
    MSIG("msig"),
    
    LSIG("lsig");

    private String value;

    SigTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SigTypeEnum fromValue(String text) {
      for (SigTypeEnum b : SigTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SigTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SigTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SigTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SigTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sig-type")
  private SigTypeEnum sigType = null;

  @SerializedName("auth-addr")
  private String authAddr = null;

  public Account address(String address) {
    this.address = address;
    return this;
  }

   /**
   * the account public key
   * @return address
  **/
  @ApiModelProperty(required = true, value = "the account public key")
  public String getAddress() {
    return address;
  }

  public void setAddress(String address) {
    this.address = address;
  }

  public Account amount(Integer amount) {
    this.amount = amount;
    return this;
  }

   /**
   * \\[algo\\] total number of MicroAlgos in the account
   * @return amount
  **/
  @ApiModelProperty(required = true, value = "\\[algo\\] total number of MicroAlgos in the account")
  public Integer getAmount() {
    return amount;
  }

  public void setAmount(Integer amount) {
    this.amount = amount;
  }

  public Account amountWithoutPendingRewards(Integer amountWithoutPendingRewards) {
    this.amountWithoutPendingRewards = amountWithoutPendingRewards;
    return this;
  }

   /**
   * specifies the amount of MicroAlgos in the account, without the pending rewards.
   * @return amountWithoutPendingRewards
  **/
  @ApiModelProperty(required = true, value = "specifies the amount of MicroAlgos in the account, without the pending rewards.")
  public Integer getAmountWithoutPendingRewards() {
    return amountWithoutPendingRewards;
  }

  public void setAmountWithoutPendingRewards(Integer amountWithoutPendingRewards) {
    this.amountWithoutPendingRewards = amountWithoutPendingRewards;
  }

  public Account appsLocalState(List<ApplicationLocalState> appsLocalState) {
    this.appsLocalState = appsLocalState;
    return this;
  }

  public Account addAppsLocalStateItem(ApplicationLocalState appsLocalStateItem) {
    if (this.appsLocalState == null) {
      this.appsLocalState = new ArrayList<ApplicationLocalState>();
    }
    this.appsLocalState.add(appsLocalStateItem);
    return this;
  }

   /**
   * \\[appl\\] applications local data stored in this account. Note the raw object uses &#x60;map[int] -&amp;gt; AppLocalState&#x60; for this type.
   * @return appsLocalState
  **/
  @ApiModelProperty(value = "\\[appl\\] applications local data stored in this account. Note the raw object uses `map[int] -&gt; AppLocalState` for this type.")
  public List<ApplicationLocalState> getAppsLocalState() {
    return appsLocalState;
  }

  public void setAppsLocalState(List<ApplicationLocalState> appsLocalState) {
    this.appsLocalState = appsLocalState;
  }

  public Account appsTotalSchema(ApplicationStateSchema appsTotalSchema) {
    this.appsTotalSchema = appsTotalSchema;
    return this;
  }

   /**
   * \\[tsch\\] stores the sum of all of the local schemas and global schemas in this account. Note: the raw account uses &#x60;StateSchema&#x60; for this type.
   * @return appsTotalSchema
  **/
  @ApiModelProperty(value = "\\[tsch\\] stores the sum of all of the local schemas and global schemas in this account. Note: the raw account uses `StateSchema` for this type.")
  public ApplicationStateSchema getAppsTotalSchema() {
    return appsTotalSchema;
  }

  public void setAppsTotalSchema(ApplicationStateSchema appsTotalSchema) {
    this.appsTotalSchema = appsTotalSchema;
  }

  public Account assets(List<AssetHolding> assets) {
    this.assets = assets;
    return this;
  }

  public Account addAssetsItem(AssetHolding assetsItem) {
    if (this.assets == null) {
      this.assets = new ArrayList<AssetHolding>();
    }
    this.assets.add(assetsItem);
    return this;
  }

   /**
   * \\[asset\\] assets held by this account. Note the raw object uses &#x60;map[int] -&amp;gt; AssetHolding&#x60; for this type.
   * @return assets
  **/
  @ApiModelProperty(value = "\\[asset\\] assets held by this account. Note the raw object uses `map[int] -&gt; AssetHolding` for this type.")
  public List<AssetHolding> getAssets() {
    return assets;
  }

  public void setAssets(List<AssetHolding> assets) {
    this.assets = assets;
  }

  public Account createdApps(List<Application> createdApps) {
    this.createdApps = createdApps;
    return this;
  }

  public Account addCreatedAppsItem(Application createdAppsItem) {
    if (this.createdApps == null) {
      this.createdApps = new ArrayList<Application>();
    }
    this.createdApps.add(createdAppsItem);
    return this;
  }

   /**
   * \\[appp\\] parameters of applications created by this account including app global data. Note: the raw account uses &#x60;map[int] -&amp;gt; AppParams&#x60; for this type.
   * @return createdApps
  **/
  @ApiModelProperty(value = "\\[appp\\] parameters of applications created by this account including app global data. Note: the raw account uses `map[int] -&gt; AppParams` for this type.")
  public List<Application> getCreatedApps() {
    return createdApps;
  }

  public void setCreatedApps(List<Application> createdApps) {
    this.createdApps = createdApps;
  }

  public Account createdAssets(List<Asset> createdAssets) {
    this.createdAssets = createdAssets;
    return this;
  }

  public Account addCreatedAssetsItem(Asset createdAssetsItem) {
    if (this.createdAssets == null) {
      this.createdAssets = new ArrayList<Asset>();
    }
    this.createdAssets.add(createdAssetsItem);
    return this;
  }

   /**
   * \\[apar\\] parameters of assets created by this account. Note: the raw account uses &#x60;map[int] -&amp;gt; Asset&#x60; for this type.
   * @return createdAssets
  **/
  @ApiModelProperty(value = "\\[apar\\] parameters of assets created by this account. Note: the raw account uses `map[int] -&gt; Asset` for this type.")
  public List<Asset> getCreatedAssets() {
    return createdAssets;
  }

  public void setCreatedAssets(List<Asset> createdAssets) {
    this.createdAssets = createdAssets;
  }

  public Account participation(AccountParticipation participation) {
    this.participation = participation;
    return this;
  }

   /**
   * Get participation
   * @return participation
  **/
  @ApiModelProperty(value = "")
  public AccountParticipation getParticipation() {
    return participation;
  }

  public void setParticipation(AccountParticipation participation) {
    this.participation = participation;
  }

  public Account pendingRewards(Integer pendingRewards) {
    this.pendingRewards = pendingRewards;
    return this;
  }

   /**
   * amount of MicroAlgos of pending rewards in this account.
   * @return pendingRewards
  **/
  @ApiModelProperty(required = true, value = "amount of MicroAlgos of pending rewards in this account.")
  public Integer getPendingRewards() {
    return pendingRewards;
  }

  public void setPendingRewards(Integer pendingRewards) {
    this.pendingRewards = pendingRewards;
  }

  public Account rewardBase(Integer rewardBase) {
    this.rewardBase = rewardBase;
    return this;
  }

   /**
   * \\[ebase\\] used as part of the rewards computation. Only applicable to accounts which are participating.
   * @return rewardBase
  **/
  @ApiModelProperty(value = "\\[ebase\\] used as part of the rewards computation. Only applicable to accounts which are participating.")
  public Integer getRewardBase() {
    return rewardBase;
  }

  public void setRewardBase(Integer rewardBase) {
    this.rewardBase = rewardBase;
  }

  public Account rewards(Integer rewards) {
    this.rewards = rewards;
    return this;
  }

   /**
   * \\[ern\\] total rewards of MicroAlgos the account has received, including pending rewards.
   * @return rewards
  **/
  @ApiModelProperty(required = true, value = "\\[ern\\] total rewards of MicroAlgos the account has received, including pending rewards.")
  public Integer getRewards() {
    return rewards;
  }

  public void setRewards(Integer rewards) {
    this.rewards = rewards;
  }

  public Account round(Integer round) {
    this.round = round;
    return this;
  }

   /**
   * The round for which this information is relevant.
   * @return round
  **/
  @ApiModelProperty(required = true, value = "The round for which this information is relevant.")
  public Integer getRound() {
    return round;
  }

  public void setRound(Integer round) {
    this.round = round;
  }

  public Account status(String status) {
    this.status = status;
    return this;
  }

   /**
   * \\[onl\\] delegation status of the account&#39;s MicroAlgos * Offline - indicates that the associated account is delegated. * Online - indicates that the associated account used as part of the delegation pool. * NotParticipating - indicates that the associated account is neither a delegator nor a delegate.
   * @return status
  **/
  @ApiModelProperty(required = true, value = "\\[onl\\] delegation status of the account's MicroAlgos * Offline - indicates that the associated account is delegated. * Online - indicates that the associated account used as part of the delegation pool. * NotParticipating - indicates that the associated account is neither a delegator nor a delegate.")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public Account sigType(SigTypeEnum sigType) {
    this.sigType = sigType;
    return this;
  }

   /**
   * Indicates what type of signature is used by this account, must be one of: * sig * msig * lsig
   * @return sigType
  **/
  @ApiModelProperty(value = "Indicates what type of signature is used by this account, must be one of: * sig * msig * lsig")
  public SigTypeEnum getSigType() {
    return sigType;
  }

  public void setSigType(SigTypeEnum sigType) {
    this.sigType = sigType;
  }

  public Account authAddr(String authAddr) {
    this.authAddr = authAddr;
    return this;
  }

   /**
   * \\[spend\\] the address against which signing should be checked. If empty, the address of the current account is used. This field can be updated in any transaction by setting the RekeyTo field.
   * @return authAddr
  **/
  @ApiModelProperty(value = "\\[spend\\] the address against which signing should be checked. If empty, the address of the current account is used. This field can be updated in any transaction by setting the RekeyTo field.")
  public String getAuthAddr() {
    return authAddr;
  }

  public void setAuthAddr(String authAddr) {
    this.authAddr = authAddr;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Account account = (Account) o;
    return Objects.equals(this.address, account.address) &&
        Objects.equals(this.amount, account.amount) &&
        Objects.equals(this.amountWithoutPendingRewards, account.amountWithoutPendingRewards) &&
        Objects.equals(this.appsLocalState, account.appsLocalState) &&
        Objects.equals(this.appsTotalSchema, account.appsTotalSchema) &&
        Objects.equals(this.assets, account.assets) &&
        Objects.equals(this.createdApps, account.createdApps) &&
        Objects.equals(this.createdAssets, account.createdAssets) &&
        Objects.equals(this.participation, account.participation) &&
        Objects.equals(this.pendingRewards, account.pendingRewards) &&
        Objects.equals(this.rewardBase, account.rewardBase) &&
        Objects.equals(this.rewards, account.rewards) &&
        Objects.equals(this.round, account.round) &&
        Objects.equals(this.status, account.status) &&
        Objects.equals(this.sigType, account.sigType) &&
        Objects.equals(this.authAddr, account.authAddr);
  }

  @Override
  public int hashCode() {
    return Objects.hash(address, amount, amountWithoutPendingRewards, appsLocalState, appsTotalSchema, assets, createdApps, createdAssets, participation, pendingRewards, rewardBase, rewards, round, status, sigType, authAddr);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Account {\n");
    
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    amountWithoutPendingRewards: ").append(toIndentedString(amountWithoutPendingRewards)).append("\n");
    sb.append("    appsLocalState: ").append(toIndentedString(appsLocalState)).append("\n");
    sb.append("    appsTotalSchema: ").append(toIndentedString(appsTotalSchema)).append("\n");
    sb.append("    assets: ").append(toIndentedString(assets)).append("\n");
    sb.append("    createdApps: ").append(toIndentedString(createdApps)).append("\n");
    sb.append("    createdAssets: ").append(toIndentedString(createdAssets)).append("\n");
    sb.append("    participation: ").append(toIndentedString(participation)).append("\n");
    sb.append("    pendingRewards: ").append(toIndentedString(pendingRewards)).append("\n");
    sb.append("    rewardBase: ").append(toIndentedString(rewardBase)).append("\n");
    sb.append("    rewards: ").append(toIndentedString(rewards)).append("\n");
    sb.append("    round: ").append(toIndentedString(round)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    sigType: ").append(toIndentedString(sigType)).append("\n");
    sb.append("    authAddr: ").append(toIndentedString(authAddr)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

