/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * AccountParticipation describes the parameters used by this account in consensus protocol.
 */
@ApiModel(description = "AccountParticipation describes the parameters used by this account in consensus protocol.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class AccountParticipation {
  @SerializedName("selection-participation-key")
  private byte[] selectionParticipationKey = null;

  @SerializedName("vote-first-valid")
  private Integer voteFirstValid = null;

  @SerializedName("vote-key-dilution")
  private Integer voteKeyDilution = null;

  @SerializedName("vote-last-valid")
  private Integer voteLastValid = null;

  @SerializedName("vote-participation-key")
  private byte[] voteParticipationKey = null;

  public AccountParticipation selectionParticipationKey(byte[] selectionParticipationKey) {
    this.selectionParticipationKey = selectionParticipationKey;
    return this;
  }

   /**
   * \\[sel\\] Selection public key (if any) currently registered for this round.
   * @return selectionParticipationKey
  **/
  @ApiModelProperty(required = true, value = "\\[sel\\] Selection public key (if any) currently registered for this round.")
  public byte[] getSelectionParticipationKey() {
    return selectionParticipationKey;
  }

  public void setSelectionParticipationKey(byte[] selectionParticipationKey) {
    this.selectionParticipationKey = selectionParticipationKey;
  }

  public AccountParticipation voteFirstValid(Integer voteFirstValid) {
    this.voteFirstValid = voteFirstValid;
    return this;
  }

   /**
   * \\[voteFst\\] First round for which this participation is valid.
   * @return voteFirstValid
  **/
  @ApiModelProperty(required = true, value = "\\[voteFst\\] First round for which this participation is valid.")
  public Integer getVoteFirstValid() {
    return voteFirstValid;
  }

  public void setVoteFirstValid(Integer voteFirstValid) {
    this.voteFirstValid = voteFirstValid;
  }

  public AccountParticipation voteKeyDilution(Integer voteKeyDilution) {
    this.voteKeyDilution = voteKeyDilution;
    return this;
  }

   /**
   * \\[voteKD\\] Number of subkeys in each batch of participation keys.
   * @return voteKeyDilution
  **/
  @ApiModelProperty(required = true, value = "\\[voteKD\\] Number of subkeys in each batch of participation keys.")
  public Integer getVoteKeyDilution() {
    return voteKeyDilution;
  }

  public void setVoteKeyDilution(Integer voteKeyDilution) {
    this.voteKeyDilution = voteKeyDilution;
  }

  public AccountParticipation voteLastValid(Integer voteLastValid) {
    this.voteLastValid = voteLastValid;
    return this;
  }

   /**
   * \\[voteLst\\] Last round for which this participation is valid.
   * @return voteLastValid
  **/
  @ApiModelProperty(required = true, value = "\\[voteLst\\] Last round for which this participation is valid.")
  public Integer getVoteLastValid() {
    return voteLastValid;
  }

  public void setVoteLastValid(Integer voteLastValid) {
    this.voteLastValid = voteLastValid;
  }

  public AccountParticipation voteParticipationKey(byte[] voteParticipationKey) {
    this.voteParticipationKey = voteParticipationKey;
    return this;
  }

   /**
   * \\[vote\\] root participation public key (if any) currently registered for this round.
   * @return voteParticipationKey
  **/
  @ApiModelProperty(required = true, value = "\\[vote\\] root participation public key (if any) currently registered for this round.")
  public byte[] getVoteParticipationKey() {
    return voteParticipationKey;
  }

  public void setVoteParticipationKey(byte[] voteParticipationKey) {
    this.voteParticipationKey = voteParticipationKey;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AccountParticipation accountParticipation = (AccountParticipation) o;
    return Arrays.equals(this.selectionParticipationKey, accountParticipation.selectionParticipationKey) &&
        Objects.equals(this.voteFirstValid, accountParticipation.voteFirstValid) &&
        Objects.equals(this.voteKeyDilution, accountParticipation.voteKeyDilution) &&
        Objects.equals(this.voteLastValid, accountParticipation.voteLastValid) &&
        Arrays.equals(this.voteParticipationKey, accountParticipation.voteParticipationKey);
  }

  @Override
  public int hashCode() {
    return Objects.hash(Arrays.hashCode(selectionParticipationKey), voteFirstValid, voteKeyDilution, voteLastValid, Arrays.hashCode(voteParticipationKey));
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AccountParticipation {\n");
    
    sb.append("    selectionParticipationKey: ").append(toIndentedString(selectionParticipationKey)).append("\n");
    sb.append("    voteFirstValid: ").append(toIndentedString(voteFirstValid)).append("\n");
    sb.append("    voteKeyDilution: ").append(toIndentedString(voteKeyDilution)).append("\n");
    sb.append("    voteLastValid: ").append(toIndentedString(voteLastValid)).append("\n");
    sb.append("    voteParticipationKey: ").append(toIndentedString(voteParticipationKey)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

