/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.sap.apimgmt.sdk.algorand_mainnet.model.ApplicationStateSchema;
import com.sap.apimgmt.sdk.algorand_mainnet.model.TealKeyValueStore;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Stores local state associated with an application.
 */
@ApiModel(description = "Stores local state associated with an application.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class ApplicationLocalState {
  @SerializedName("id")
  private Integer id = null;

  @SerializedName("schema")
  private ApplicationStateSchema schema = null;

  @SerializedName("key-value")
  private TealKeyValueStore keyValue = null;

  public ApplicationLocalState id(Integer id) {
    this.id = id;
    return this;
  }

   /**
   * The application which this local state is for.
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The application which this local state is for.")
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  public ApplicationLocalState schema(ApplicationStateSchema schema) {
    this.schema = schema;
    return this;
  }

   /**
   * \\[hsch\\] schema.
   * @return schema
  **/
  @ApiModelProperty(required = true, value = "\\[hsch\\] schema.")
  public ApplicationStateSchema getSchema() {
    return schema;
  }

  public void setSchema(ApplicationStateSchema schema) {
    this.schema = schema;
  }

  public ApplicationLocalState keyValue(TealKeyValueStore keyValue) {
    this.keyValue = keyValue;
    return this;
  }

   /**
   * \\[tkv\\] storage.
   * @return keyValue
  **/
  @ApiModelProperty(required = true, value = "\\[tkv\\] storage.")
  public TealKeyValueStore getKeyValue() {
    return keyValue;
  }

  public void setKeyValue(TealKeyValueStore keyValue) {
    this.keyValue = keyValue;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationLocalState applicationLocalState = (ApplicationLocalState) o;
    return Objects.equals(this.id, applicationLocalState.id) &&
        Objects.equals(this.schema, applicationLocalState.schema) &&
        Objects.equals(this.keyValue, applicationLocalState.keyValue);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, schema, keyValue);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationLocalState {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    schema: ").append(toIndentedString(schema)).append("\n");
    sb.append("    keyValue: ").append(toIndentedString(keyValue)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

