/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.sap.apimgmt.sdk.algorand_mainnet.model.ApplicationStateSchema;
import com.sap.apimgmt.sdk.algorand_mainnet.model.TealKeyValueStore;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Stores the global information associated with an application.
 */
@ApiModel(description = "Stores the global information associated with an application.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class ApplicationParams {
  @SerializedName("creator")
  private String creator = null;

  @SerializedName("approval-program")
  private byte[] approvalProgram = null;

  @SerializedName("clear-state-program")
  private byte[] clearStateProgram = null;

  @SerializedName("local-state-schema")
  private ApplicationStateSchema localStateSchema = null;

  @SerializedName("global-state-schema")
  private ApplicationStateSchema globalStateSchema = null;

  @SerializedName("global-state")
  private TealKeyValueStore globalState = null;

  public ApplicationParams creator(String creator) {
    this.creator = creator;
    return this;
  }

   /**
   * The address that created this application. This is the address where the parameters and global state for this application can be found.
   * @return creator
  **/
  @ApiModelProperty(required = true, value = "The address that created this application. This is the address where the parameters and global state for this application can be found.")
  public String getCreator() {
    return creator;
  }

  public void setCreator(String creator) {
    this.creator = creator;
  }

  public ApplicationParams approvalProgram(byte[] approvalProgram) {
    this.approvalProgram = approvalProgram;
    return this;
  }

   /**
   * \\[approv\\] approval program.
   * @return approvalProgram
  **/
  @ApiModelProperty(required = true, value = "\\[approv\\] approval program.")
  public byte[] getApprovalProgram() {
    return approvalProgram;
  }

  public void setApprovalProgram(byte[] approvalProgram) {
    this.approvalProgram = approvalProgram;
  }

  public ApplicationParams clearStateProgram(byte[] clearStateProgram) {
    this.clearStateProgram = clearStateProgram;
    return this;
  }

   /**
   * \\[clearp\\] approval program.
   * @return clearStateProgram
  **/
  @ApiModelProperty(required = true, value = "\\[clearp\\] approval program.")
  public byte[] getClearStateProgram() {
    return clearStateProgram;
  }

  public void setClearStateProgram(byte[] clearStateProgram) {
    this.clearStateProgram = clearStateProgram;
  }

  public ApplicationParams localStateSchema(ApplicationStateSchema localStateSchema) {
    this.localStateSchema = localStateSchema;
    return this;
  }

   /**
   * [\\lsch\\] local schema
   * @return localStateSchema
  **/
  @ApiModelProperty(value = "[\\lsch\\] local schema")
  public ApplicationStateSchema getLocalStateSchema() {
    return localStateSchema;
  }

  public void setLocalStateSchema(ApplicationStateSchema localStateSchema) {
    this.localStateSchema = localStateSchema;
  }

  public ApplicationParams globalStateSchema(ApplicationStateSchema globalStateSchema) {
    this.globalStateSchema = globalStateSchema;
    return this;
  }

   /**
   * [\\lsch\\] global schema
   * @return globalStateSchema
  **/
  @ApiModelProperty(value = "[\\lsch\\] global schema")
  public ApplicationStateSchema getGlobalStateSchema() {
    return globalStateSchema;
  }

  public void setGlobalStateSchema(ApplicationStateSchema globalStateSchema) {
    this.globalStateSchema = globalStateSchema;
  }

  public ApplicationParams globalState(TealKeyValueStore globalState) {
    this.globalState = globalState;
    return this;
  }

   /**
   * [\\gs\\] global schema
   * @return globalState
  **/
  @ApiModelProperty(value = "[\\gs\\] global schema")
  public TealKeyValueStore getGlobalState() {
    return globalState;
  }

  public void setGlobalState(TealKeyValueStore globalState) {
    this.globalState = globalState;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationParams applicationParams = (ApplicationParams) o;
    return Objects.equals(this.creator, applicationParams.creator) &&
        Arrays.equals(this.approvalProgram, applicationParams.approvalProgram) &&
        Arrays.equals(this.clearStateProgram, applicationParams.clearStateProgram) &&
        Objects.equals(this.localStateSchema, applicationParams.localStateSchema) &&
        Objects.equals(this.globalStateSchema, applicationParams.globalStateSchema) &&
        Objects.equals(this.globalState, applicationParams.globalState);
  }

  @Override
  public int hashCode() {
    return Objects.hash(creator, Arrays.hashCode(approvalProgram), Arrays.hashCode(clearStateProgram), localStateSchema, globalStateSchema, globalState);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationParams {\n");
    
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    approvalProgram: ").append(toIndentedString(approvalProgram)).append("\n");
    sb.append("    clearStateProgram: ").append(toIndentedString(clearStateProgram)).append("\n");
    sb.append("    localStateSchema: ").append(toIndentedString(localStateSchema)).append("\n");
    sb.append("    globalStateSchema: ").append(toIndentedString(globalStateSchema)).append("\n");
    sb.append("    globalState: ").append(toIndentedString(globalState)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

