/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Describes an asset held by an account. Definition: data/basics/userBalance.go : AssetHolding
 */
@ApiModel(description = "Describes an asset held by an account. Definition: data/basics/userBalance.go : AssetHolding")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class AssetHolding {
  @SerializedName("amount")
  private Integer amount = null;

  @SerializedName("asset-id")
  private Integer assetId = null;

  @SerializedName("creator")
  private String creator = null;

  @SerializedName("is-frozen")
  private Boolean isFrozen = null;

  public AssetHolding amount(Integer amount) {
    this.amount = amount;
    return this;
  }

   /**
   * \\[a\\] number of units held.
   * @return amount
  **/
  @ApiModelProperty(required = true, value = "\\[a\\] number of units held.")
  public Integer getAmount() {
    return amount;
  }

  public void setAmount(Integer amount) {
    this.amount = amount;
  }

  public AssetHolding assetId(Integer assetId) {
    this.assetId = assetId;
    return this;
  }

   /**
   * Asset ID of the holding.
   * @return assetId
  **/
  @ApiModelProperty(required = true, value = "Asset ID of the holding.")
  public Integer getAssetId() {
    return assetId;
  }

  public void setAssetId(Integer assetId) {
    this.assetId = assetId;
  }

  public AssetHolding creator(String creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Address that created this asset. This is the address where the parameters for this asset can be found, and also the address where unwanted asset units can be sent in the worst case.
   * @return creator
  **/
  @ApiModelProperty(required = true, value = "Address that created this asset. This is the address where the parameters for this asset can be found, and also the address where unwanted asset units can be sent in the worst case.")
  public String getCreator() {
    return creator;
  }

  public void setCreator(String creator) {
    this.creator = creator;
  }

  public AssetHolding isFrozen(Boolean isFrozen) {
    this.isFrozen = isFrozen;
    return this;
  }

   /**
   * \\[f\\] whether or not the holding is frozen.
   * @return isFrozen
  **/
  @ApiModelProperty(required = true, value = "\\[f\\] whether or not the holding is frozen.")
  public Boolean isIsFrozen() {
    return isFrozen;
  }

  public void setIsFrozen(Boolean isFrozen) {
    this.isFrozen = isFrozen;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AssetHolding assetHolding = (AssetHolding) o;
    return Objects.equals(this.amount, assetHolding.amount) &&
        Objects.equals(this.assetId, assetHolding.assetId) &&
        Objects.equals(this.creator, assetHolding.creator) &&
        Objects.equals(this.isFrozen, assetHolding.isFrozen);
  }

  @Override
  public int hashCode() {
    return Objects.hash(amount, assetId, creator, isFrozen);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AssetHolding {\n");
    
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    assetId: ").append(toIndentedString(assetId)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    isFrozen: ").append(toIndentedString(isFrozen)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

