/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * AssetParams specifies the parameters for an asset. \\[apar\\] when part of an AssetConfig transaction. Definition: data/transactions/asset.go : AssetParams
 */
@ApiModel(description = "AssetParams specifies the parameters for an asset. \\[apar\\] when part of an AssetConfig transaction. Definition: data/transactions/asset.go : AssetParams")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class AssetParams {
  @SerializedName("clawback")
  private String clawback = null;

  @SerializedName("creator")
  private String creator = null;

  @SerializedName("decimals")
  private Integer decimals = null;

  @SerializedName("default-frozen")
  private Boolean defaultFrozen = null;

  @SerializedName("freeze")
  private String freeze = null;

  @SerializedName("manager")
  private String manager = null;

  @SerializedName("metadata-hash")
  private byte[] metadataHash = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("reserve")
  private String reserve = null;

  @SerializedName("total")
  private Integer total = null;

  @SerializedName("unit-name")
  private String unitName = null;

  @SerializedName("url")
  private String url = null;

  public AssetParams clawback(String clawback) {
    this.clawback = clawback;
    return this;
  }

   /**
   * \\[c\\] Address of account used to clawback holdings of this asset. If empty, clawback is not permitted.
   * @return clawback
  **/
  @ApiModelProperty(value = "\\[c\\] Address of account used to clawback holdings of this asset. If empty, clawback is not permitted.")
  public String getClawback() {
    return clawback;
  }

  public void setClawback(String clawback) {
    this.clawback = clawback;
  }

  public AssetParams creator(String creator) {
    this.creator = creator;
    return this;
  }

   /**
   * The address that created this asset. This is the address where the parameters for this asset can be found, and also the address where unwanted asset units can be sent in the worst case.
   * @return creator
  **/
  @ApiModelProperty(required = true, value = "The address that created this asset. This is the address where the parameters for this asset can be found, and also the address where unwanted asset units can be sent in the worst case.")
  public String getCreator() {
    return creator;
  }

  public void setCreator(String creator) {
    this.creator = creator;
  }

  public AssetParams decimals(Integer decimals) {
    this.decimals = decimals;
    return this;
  }

   /**
   * \\[dc\\] The number of digits to use after the decimal point when displaying this asset. If 0, the asset is not divisible. If 1, the base unit of the asset is in tenths. If 2, the base unit of the asset is in hundredths, and so on. This value must be between 0 and 19 (inclusive).
   * minimum: 0
   * maximum: 19
   * @return decimals
  **/
  @ApiModelProperty(required = true, value = "\\[dc\\] The number of digits to use after the decimal point when displaying this asset. If 0, the asset is not divisible. If 1, the base unit of the asset is in tenths. If 2, the base unit of the asset is in hundredths, and so on. This value must be between 0 and 19 (inclusive).")
  public Integer getDecimals() {
    return decimals;
  }

  public void setDecimals(Integer decimals) {
    this.decimals = decimals;
  }

  public AssetParams defaultFrozen(Boolean defaultFrozen) {
    this.defaultFrozen = defaultFrozen;
    return this;
  }

   /**
   * \\[df\\] Whether holdings of this asset are frozen by default.
   * @return defaultFrozen
  **/
  @ApiModelProperty(value = "\\[df\\] Whether holdings of this asset are frozen by default.")
  public Boolean isDefaultFrozen() {
    return defaultFrozen;
  }

  public void setDefaultFrozen(Boolean defaultFrozen) {
    this.defaultFrozen = defaultFrozen;
  }

  public AssetParams freeze(String freeze) {
    this.freeze = freeze;
    return this;
  }

   /**
   * \\[f\\] Address of account used to freeze holdings of this asset. If empty, freezing is not permitted.
   * @return freeze
  **/
  @ApiModelProperty(value = "\\[f\\] Address of account used to freeze holdings of this asset. If empty, freezing is not permitted.")
  public String getFreeze() {
    return freeze;
  }

  public void setFreeze(String freeze) {
    this.freeze = freeze;
  }

  public AssetParams manager(String manager) {
    this.manager = manager;
    return this;
  }

   /**
   * \\[m\\] Address of account used to manage the keys of this asset and to destroy it.
   * @return manager
  **/
  @ApiModelProperty(value = "\\[m\\] Address of account used to manage the keys of this asset and to destroy it.")
  public String getManager() {
    return manager;
  }

  public void setManager(String manager) {
    this.manager = manager;
  }

  public AssetParams metadataHash(byte[] metadataHash) {
    this.metadataHash = metadataHash;
    return this;
  }

   /**
   * \\[am\\] A commitment to some unspecified asset metadata. The format of this metadata is up to the application.
   * @return metadataHash
  **/
  @ApiModelProperty(value = "\\[am\\] A commitment to some unspecified asset metadata. The format of this metadata is up to the application.")
  public byte[] getMetadataHash() {
    return metadataHash;
  }

  public void setMetadataHash(byte[] metadataHash) {
    this.metadataHash = metadataHash;
  }

  public AssetParams name(String name) {
    this.name = name;
    return this;
  }

   /**
   * \\[an\\] Name of this asset, as supplied by the creator.
   * @return name
  **/
  @ApiModelProperty(value = "\\[an\\] Name of this asset, as supplied by the creator.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public AssetParams reserve(String reserve) {
    this.reserve = reserve;
    return this;
  }

   /**
   * \\[r\\] Address of account holding reserve (non-minted) units of this asset.
   * @return reserve
  **/
  @ApiModelProperty(value = "\\[r\\] Address of account holding reserve (non-minted) units of this asset.")
  public String getReserve() {
    return reserve;
  }

  public void setReserve(String reserve) {
    this.reserve = reserve;
  }

  public AssetParams total(Integer total) {
    this.total = total;
    return this;
  }

   /**
   * \\[t\\] The total number of units of this asset.
   * @return total
  **/
  @ApiModelProperty(required = true, value = "\\[t\\] The total number of units of this asset.")
  public Integer getTotal() {
    return total;
  }

  public void setTotal(Integer total) {
    this.total = total;
  }

  public AssetParams unitName(String unitName) {
    this.unitName = unitName;
    return this;
  }

   /**
   * \\[un\\] Name of a unit of this asset, as supplied by the creator.
   * @return unitName
  **/
  @ApiModelProperty(value = "\\[un\\] Name of a unit of this asset, as supplied by the creator.")
  public String getUnitName() {
    return unitName;
  }

  public void setUnitName(String unitName) {
    this.unitName = unitName;
  }

  public AssetParams url(String url) {
    this.url = url;
    return this;
  }

   /**
   * \\[au\\] URL where more information about the asset can be retrieved.
   * @return url
  **/
  @ApiModelProperty(value = "\\[au\\] URL where more information about the asset can be retrieved.")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AssetParams assetParams = (AssetParams) o;
    return Objects.equals(this.clawback, assetParams.clawback) &&
        Objects.equals(this.creator, assetParams.creator) &&
        Objects.equals(this.decimals, assetParams.decimals) &&
        Objects.equals(this.defaultFrozen, assetParams.defaultFrozen) &&
        Objects.equals(this.freeze, assetParams.freeze) &&
        Objects.equals(this.manager, assetParams.manager) &&
        Arrays.equals(this.metadataHash, assetParams.metadataHash) &&
        Objects.equals(this.name, assetParams.name) &&
        Objects.equals(this.reserve, assetParams.reserve) &&
        Objects.equals(this.total, assetParams.total) &&
        Objects.equals(this.unitName, assetParams.unitName) &&
        Objects.equals(this.url, assetParams.url);
  }

  @Override
  public int hashCode() {
    return Objects.hash(clawback, creator, decimals, defaultFrozen, freeze, manager, Arrays.hashCode(metadataHash), name, reserve, total, unitName, url);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AssetParams {\n");
    
    sb.append("    clawback: ").append(toIndentedString(clawback)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    decimals: ").append(toIndentedString(decimals)).append("\n");
    sb.append("    defaultFrozen: ").append(toIndentedString(defaultFrozen)).append("\n");
    sb.append("    freeze: ").append(toIndentedString(freeze)).append("\n");
    sb.append("    manager: ").append(toIndentedString(manager)).append("\n");
    sb.append("    metadataHash: ").append(toIndentedString(metadataHash)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    reserve: ").append(toIndentedString(reserve)).append("\n");
    sb.append("    total: ").append(toIndentedString(total)).append("\n");
    sb.append("    unitName: ").append(toIndentedString(unitName)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

