/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * NodeStatus contains the information about a node status
 */
@ApiModel(description = "NodeStatus contains the information about a node status")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class InlineResponse2003 {
  @SerializedName("catchup-time")
  private Integer catchupTime = null;

  @SerializedName("last-round")
  private Integer lastRound = null;

  @SerializedName("last-version")
  private String lastVersion = null;

  @SerializedName("next-version")
  private String nextVersion = null;

  @SerializedName("next-version-round")
  private Integer nextVersionRound = null;

  @SerializedName("next-version-supported")
  private Boolean nextVersionSupported = null;

  @SerializedName("stopped-at-unsupported-round")
  private Boolean stoppedAtUnsupportedRound = null;

  @SerializedName("time-since-last-round")
  private Integer timeSinceLastRound = null;

  public InlineResponse2003 catchupTime(Integer catchupTime) {
    this.catchupTime = catchupTime;
    return this;
  }

   /**
   * CatchupTime in nanoseconds
   * @return catchupTime
  **/
  @ApiModelProperty(required = true, value = "CatchupTime in nanoseconds")
  public Integer getCatchupTime() {
    return catchupTime;
  }

  public void setCatchupTime(Integer catchupTime) {
    this.catchupTime = catchupTime;
  }

  public InlineResponse2003 lastRound(Integer lastRound) {
    this.lastRound = lastRound;
    return this;
  }

   /**
   * LastRound indicates the last round seen
   * @return lastRound
  **/
  @ApiModelProperty(required = true, value = "LastRound indicates the last round seen")
  public Integer getLastRound() {
    return lastRound;
  }

  public void setLastRound(Integer lastRound) {
    this.lastRound = lastRound;
  }

  public InlineResponse2003 lastVersion(String lastVersion) {
    this.lastVersion = lastVersion;
    return this;
  }

   /**
   * LastVersion indicates the last consensus version supported
   * @return lastVersion
  **/
  @ApiModelProperty(required = true, value = "LastVersion indicates the last consensus version supported")
  public String getLastVersion() {
    return lastVersion;
  }

  public void setLastVersion(String lastVersion) {
    this.lastVersion = lastVersion;
  }

  public InlineResponse2003 nextVersion(String nextVersion) {
    this.nextVersion = nextVersion;
    return this;
  }

   /**
   * NextVersion of consensus protocol to use
   * @return nextVersion
  **/
  @ApiModelProperty(required = true, value = "NextVersion of consensus protocol to use")
  public String getNextVersion() {
    return nextVersion;
  }

  public void setNextVersion(String nextVersion) {
    this.nextVersion = nextVersion;
  }

  public InlineResponse2003 nextVersionRound(Integer nextVersionRound) {
    this.nextVersionRound = nextVersionRound;
    return this;
  }

   /**
   * NextVersionRound is the round at which the next consensus version will apply
   * @return nextVersionRound
  **/
  @ApiModelProperty(required = true, value = "NextVersionRound is the round at which the next consensus version will apply")
  public Integer getNextVersionRound() {
    return nextVersionRound;
  }

  public void setNextVersionRound(Integer nextVersionRound) {
    this.nextVersionRound = nextVersionRound;
  }

  public InlineResponse2003 nextVersionSupported(Boolean nextVersionSupported) {
    this.nextVersionSupported = nextVersionSupported;
    return this;
  }

   /**
   * NextVersionSupported indicates whether the next consensus version is supported by this node
   * @return nextVersionSupported
  **/
  @ApiModelProperty(required = true, value = "NextVersionSupported indicates whether the next consensus version is supported by this node")
  public Boolean isNextVersionSupported() {
    return nextVersionSupported;
  }

  public void setNextVersionSupported(Boolean nextVersionSupported) {
    this.nextVersionSupported = nextVersionSupported;
  }

  public InlineResponse2003 stoppedAtUnsupportedRound(Boolean stoppedAtUnsupportedRound) {
    this.stoppedAtUnsupportedRound = stoppedAtUnsupportedRound;
    return this;
  }

   /**
   * StoppedAtUnsupportedRound indicates that the node does not support the new rounds and has stopped making progress
   * @return stoppedAtUnsupportedRound
  **/
  @ApiModelProperty(required = true, value = "StoppedAtUnsupportedRound indicates that the node does not support the new rounds and has stopped making progress")
  public Boolean isStoppedAtUnsupportedRound() {
    return stoppedAtUnsupportedRound;
  }

  public void setStoppedAtUnsupportedRound(Boolean stoppedAtUnsupportedRound) {
    this.stoppedAtUnsupportedRound = stoppedAtUnsupportedRound;
  }

  public InlineResponse2003 timeSinceLastRound(Integer timeSinceLastRound) {
    this.timeSinceLastRound = timeSinceLastRound;
    return this;
  }

   /**
   * TimeSinceLastRound in nanoseconds
   * @return timeSinceLastRound
  **/
  @ApiModelProperty(required = true, value = "TimeSinceLastRound in nanoseconds")
  public Integer getTimeSinceLastRound() {
    return timeSinceLastRound;
  }

  public void setTimeSinceLastRound(Integer timeSinceLastRound) {
    this.timeSinceLastRound = timeSinceLastRound;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InlineResponse2003 inlineResponse2003 = (InlineResponse2003) o;
    return Objects.equals(this.catchupTime, inlineResponse2003.catchupTime) &&
        Objects.equals(this.lastRound, inlineResponse2003.lastRound) &&
        Objects.equals(this.lastVersion, inlineResponse2003.lastVersion) &&
        Objects.equals(this.nextVersion, inlineResponse2003.nextVersion) &&
        Objects.equals(this.nextVersionRound, inlineResponse2003.nextVersionRound) &&
        Objects.equals(this.nextVersionSupported, inlineResponse2003.nextVersionSupported) &&
        Objects.equals(this.stoppedAtUnsupportedRound, inlineResponse2003.stoppedAtUnsupportedRound) &&
        Objects.equals(this.timeSinceLastRound, inlineResponse2003.timeSinceLastRound);
  }

  @Override
  public int hashCode() {
    return Objects.hash(catchupTime, lastRound, lastVersion, nextVersion, nextVersionRound, nextVersionSupported, stoppedAtUnsupportedRound, timeSinceLastRound);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InlineResponse2003 {\n");
    
    sb.append("    catchupTime: ").append(toIndentedString(catchupTime)).append("\n");
    sb.append("    lastRound: ").append(toIndentedString(lastRound)).append("\n");
    sb.append("    lastVersion: ").append(toIndentedString(lastVersion)).append("\n");
    sb.append("    nextVersion: ").append(toIndentedString(nextVersion)).append("\n");
    sb.append("    nextVersionRound: ").append(toIndentedString(nextVersionRound)).append("\n");
    sb.append("    nextVersionSupported: ").append(toIndentedString(nextVersionSupported)).append("\n");
    sb.append("    stoppedAtUnsupportedRound: ").append(toIndentedString(stoppedAtUnsupportedRound)).append("\n");
    sb.append("    timeSinceLastRound: ").append(toIndentedString(timeSinceLastRound)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

