/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * TransactionParams contains the parameters that help a client construct a new transaction.
 */
@ApiModel(description = "TransactionParams contains the parameters that help a client construct a new transaction.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class InlineResponse2005 {
  @SerializedName("consensus-version")
  private String consensusVersion = null;

  @SerializedName("fee")
  private Integer fee = null;

  @SerializedName("genesis-hash")
  private byte[] genesisHash = null;

  @SerializedName("genesis-id")
  private String genesisId = null;

  @SerializedName("last-round")
  private Integer lastRound = null;

  @SerializedName("min-fee")
  private Integer minFee = null;

  public InlineResponse2005 consensusVersion(String consensusVersion) {
    this.consensusVersion = consensusVersion;
    return this;
  }

   /**
   * ConsensusVersion indicates the consensus protocol version as of LastRound.
   * @return consensusVersion
  **/
  @ApiModelProperty(required = true, value = "ConsensusVersion indicates the consensus protocol version as of LastRound.")
  public String getConsensusVersion() {
    return consensusVersion;
  }

  public void setConsensusVersion(String consensusVersion) {
    this.consensusVersion = consensusVersion;
  }

  public InlineResponse2005 fee(Integer fee) {
    this.fee = fee;
    return this;
  }

   /**
   * Fee is the suggested transaction fee Fee is in units of micro-Algos per byte. Fee may fall to zero but transactions must still have a fee of at least MinTxnFee for the current network protocol.
   * @return fee
  **/
  @ApiModelProperty(required = true, value = "Fee is the suggested transaction fee Fee is in units of micro-Algos per byte. Fee may fall to zero but transactions must still have a fee of at least MinTxnFee for the current network protocol.")
  public Integer getFee() {
    return fee;
  }

  public void setFee(Integer fee) {
    this.fee = fee;
  }

  public InlineResponse2005 genesisHash(byte[] genesisHash) {
    this.genesisHash = genesisHash;
    return this;
  }

   /**
   * GenesisHash is the hash of the genesis block.
   * @return genesisHash
  **/
  @ApiModelProperty(required = true, value = "GenesisHash is the hash of the genesis block.")
  public byte[] getGenesisHash() {
    return genesisHash;
  }

  public void setGenesisHash(byte[] genesisHash) {
    this.genesisHash = genesisHash;
  }

  public InlineResponse2005 genesisId(String genesisId) {
    this.genesisId = genesisId;
    return this;
  }

   /**
   * GenesisID is an ID listed in the genesis block.
   * @return genesisId
  **/
  @ApiModelProperty(required = true, value = "GenesisID is an ID listed in the genesis block.")
  public String getGenesisId() {
    return genesisId;
  }

  public void setGenesisId(String genesisId) {
    this.genesisId = genesisId;
  }

  public InlineResponse2005 lastRound(Integer lastRound) {
    this.lastRound = lastRound;
    return this;
  }

   /**
   * LastRound indicates the last round seen
   * @return lastRound
  **/
  @ApiModelProperty(required = true, value = "LastRound indicates the last round seen")
  public Integer getLastRound() {
    return lastRound;
  }

  public void setLastRound(Integer lastRound) {
    this.lastRound = lastRound;
  }

  public InlineResponse2005 minFee(Integer minFee) {
    this.minFee = minFee;
    return this;
  }

   /**
   * The minimum transaction fee (not per byte) required for the txn to validate for the current network protocol.
   * @return minFee
  **/
  @ApiModelProperty(required = true, value = "The minimum transaction fee (not per byte) required for the txn to validate for the current network protocol.")
  public Integer getMinFee() {
    return minFee;
  }

  public void setMinFee(Integer minFee) {
    this.minFee = minFee;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InlineResponse2005 inlineResponse2005 = (InlineResponse2005) o;
    return Objects.equals(this.consensusVersion, inlineResponse2005.consensusVersion) &&
        Objects.equals(this.fee, inlineResponse2005.fee) &&
        Arrays.equals(this.genesisHash, inlineResponse2005.genesisHash) &&
        Objects.equals(this.genesisId, inlineResponse2005.genesisId) &&
        Objects.equals(this.lastRound, inlineResponse2005.lastRound) &&
        Objects.equals(this.minFee, inlineResponse2005.minFee);
  }

  @Override
  public int hashCode() {
    return Objects.hash(consensusVersion, fee, Arrays.hashCode(genesisHash), genesisId, lastRound, minFee);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InlineResponse2005 {\n");
    
    sb.append("    consensusVersion: ").append(toIndentedString(consensusVersion)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    genesisHash: ").append(toIndentedString(genesisHash)).append("\n");
    sb.append("    genesisId: ").append(toIndentedString(genesisId)).append("\n");
    sb.append("    lastRound: ").append(toIndentedString(lastRound)).append("\n");
    sb.append("    minFee: ").append(toIndentedString(minFee)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

