/*
 * Algorand Mainnet
 * <p>SAP Integration with the Productive node of Algorand's pure Proof of Stake blockchain platform, enabling the creation of sophisticated application development. The API gives the interoperability between SAP enterprise applications and the distributed ledger on Mainnet network.</p>
 *
 * OpenAPI spec version: 1.0
 * Contact: solutions@alphacons.gr
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.sap.apimgmt.sdk.algorand_mainnet.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Details about a pending transaction. If the transaction was recently confirmed, includes confirmation details like the round and reward details.
 */
@ApiModel(description = "Details about a pending transaction. If the transaction was recently confirmed, includes confirmation details like the round and reward details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-03-17T18:32:03.829Z")
public class InlineResponse2006 {
  @SerializedName("asset-index")
  private Integer assetIndex = null;

  @SerializedName("close-rewards")
  private Integer closeRewards = null;

  @SerializedName("closing-amount")
  private Integer closingAmount = null;

  @SerializedName("confirmed-round")
  private Integer confirmedRound = null;

  @SerializedName("pool-error")
  private String poolError = null;

  @SerializedName("receiver-rewards")
  private Integer receiverRewards = null;

  @SerializedName("sender-rewards")
  private Integer senderRewards = null;

  @SerializedName("txn")
  private Object txn = null;

  public InlineResponse2006 assetIndex(Integer assetIndex) {
    this.assetIndex = assetIndex;
    return this;
  }

   /**
   * The asset index if the transaction was found and it created an asset.
   * @return assetIndex
  **/
  @ApiModelProperty(value = "The asset index if the transaction was found and it created an asset.")
  public Integer getAssetIndex() {
    return assetIndex;
  }

  public void setAssetIndex(Integer assetIndex) {
    this.assetIndex = assetIndex;
  }

  public InlineResponse2006 closeRewards(Integer closeRewards) {
    this.closeRewards = closeRewards;
    return this;
  }

   /**
   * Rewards in microalgos applied to the close remainder to account.
   * @return closeRewards
  **/
  @ApiModelProperty(value = "Rewards in microalgos applied to the close remainder to account.")
  public Integer getCloseRewards() {
    return closeRewards;
  }

  public void setCloseRewards(Integer closeRewards) {
    this.closeRewards = closeRewards;
  }

  public InlineResponse2006 closingAmount(Integer closingAmount) {
    this.closingAmount = closingAmount;
    return this;
  }

   /**
   * Closing amount for the transaction.
   * @return closingAmount
  **/
  @ApiModelProperty(value = "Closing amount for the transaction.")
  public Integer getClosingAmount() {
    return closingAmount;
  }

  public void setClosingAmount(Integer closingAmount) {
    this.closingAmount = closingAmount;
  }

  public InlineResponse2006 confirmedRound(Integer confirmedRound) {
    this.confirmedRound = confirmedRound;
    return this;
  }

   /**
   * The round where this transaction was confirmed, if present.
   * @return confirmedRound
  **/
  @ApiModelProperty(value = "The round where this transaction was confirmed, if present.")
  public Integer getConfirmedRound() {
    return confirmedRound;
  }

  public void setConfirmedRound(Integer confirmedRound) {
    this.confirmedRound = confirmedRound;
  }

  public InlineResponse2006 poolError(String poolError) {
    this.poolError = poolError;
    return this;
  }

   /**
   * Indicates that the transaction was kicked out of this node&#39;s transaction pool (and specifies why that happened). An empty string indicates the transaction wasn&#39;t kicked out of this node&#39;s txpool due to an error.
   * @return poolError
  **/
  @ApiModelProperty(required = true, value = "Indicates that the transaction was kicked out of this node's transaction pool (and specifies why that happened). An empty string indicates the transaction wasn't kicked out of this node's txpool due to an error.")
  public String getPoolError() {
    return poolError;
  }

  public void setPoolError(String poolError) {
    this.poolError = poolError;
  }

  public InlineResponse2006 receiverRewards(Integer receiverRewards) {
    this.receiverRewards = receiverRewards;
    return this;
  }

   /**
   * Rewards in microalgos applied to the receiver account.
   * @return receiverRewards
  **/
  @ApiModelProperty(value = "Rewards in microalgos applied to the receiver account.")
  public Integer getReceiverRewards() {
    return receiverRewards;
  }

  public void setReceiverRewards(Integer receiverRewards) {
    this.receiverRewards = receiverRewards;
  }

  public InlineResponse2006 senderRewards(Integer senderRewards) {
    this.senderRewards = senderRewards;
    return this;
  }

   /**
   * Rewards in microalgos applied to the sender account.
   * @return senderRewards
  **/
  @ApiModelProperty(value = "Rewards in microalgos applied to the sender account.")
  public Integer getSenderRewards() {
    return senderRewards;
  }

  public void setSenderRewards(Integer senderRewards) {
    this.senderRewards = senderRewards;
  }

  public InlineResponse2006 txn(Object txn) {
    this.txn = txn;
    return this;
  }

   /**
   * The raw signed transaction.
   * @return txn
  **/
  @ApiModelProperty(required = true, value = "The raw signed transaction.")
  public Object getTxn() {
    return txn;
  }

  public void setTxn(Object txn) {
    this.txn = txn;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InlineResponse2006 inlineResponse2006 = (InlineResponse2006) o;
    return Objects.equals(this.assetIndex, inlineResponse2006.assetIndex) &&
        Objects.equals(this.closeRewards, inlineResponse2006.closeRewards) &&
        Objects.equals(this.closingAmount, inlineResponse2006.closingAmount) &&
        Objects.equals(this.confirmedRound, inlineResponse2006.confirmedRound) &&
        Objects.equals(this.poolError, inlineResponse2006.poolError) &&
        Objects.equals(this.receiverRewards, inlineResponse2006.receiverRewards) &&
        Objects.equals(this.senderRewards, inlineResponse2006.senderRewards) &&
        Objects.equals(this.txn, inlineResponse2006.txn);
  }

  @Override
  public int hashCode() {
    return Objects.hash(assetIndex, closeRewards, closingAmount, confirmedRound, poolError, receiverRewards, senderRewards, txn);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InlineResponse2006 {\n");
    
    sb.append("    assetIndex: ").append(toIndentedString(assetIndex)).append("\n");
    sb.append("    closeRewards: ").append(toIndentedString(closeRewards)).append("\n");
    sb.append("    closingAmount: ").append(toIndentedString(closingAmount)).append("\n");
    sb.append("    confirmedRound: ").append(toIndentedString(confirmedRound)).append("\n");
    sb.append("    poolError: ").append(toIndentedString(poolError)).append("\n");
    sb.append("    receiverRewards: ").append(toIndentedString(receiverRewards)).append("\n");
    sb.append("    senderRewards: ").append(toIndentedString(senderRewards)).append("\n");
    sb.append("    txn: ").append(toIndentedString(txn)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

